const app = getApp()
import $http from './http'
// 获取创建会议室的会议室列表
export function getMeetingRoom(data) {
  return $http({
    method: 'get',
    data: data,
    url: '/meet/meeting-room/page',
  })
}

// 获取会议室分类
// 办公区域
// OFFICE_LOCATION(0,"meeting_room_location")
// 会议室设施
// OFFICE_FACILITY(1,"meeting_room_facility")
// 会议室分类
// OFFICE_CATEGORY(2,"meeting_room_category")
export function getLabelTree(data) {
  return $http({
    method: 'get',
    data: data,
    url: '/admin/label/tree',
  })
}
// 更新办公区域，设施，分类
export function getMettingRoomLabelUpdate(data) {
  return $http({
    method: 'POST',
    data: JSON.stringify(data),
    url: '/admin/label/update',
  })
}
// 添加办公区域、会议室分类、会议室设置
export function getMettingRoomLabelSave(data) {
  return $http({
    method: 'POST',
    data: JSON.stringify(data),
    url: '/admin/label/save',
  })
}
// 删除办公区域、会议室分类、会议室设置
export function getMettingRoomLabelRemove(data) {
  return $http({
    method: 'get',
    data: data,
    url: `/admin/label/remove/${data}`,
  })
}
// 删除会议室
export function getRemoveMeetingRoom(data) {
  return $http({
    method: 'get',
    data: '',
    url: `/meet/meeting-room/remove/${data}`,
  })
}
// 创建会议室
export function saveMettingRoom(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: '/meet/meeting-room/save',
  })
}
// 修改会议室
export function mettingRoomUpdate(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: '/meet/meeting-room/update',
  })
}
// 获取会议室详情
export function getMeetingRoomVOByUuid(data) {
  return $http({
    method: 'get',
    data: '',
    url: `/meet/meeting-room/getMeetingRoomVOByUuid/${data}`,
  })
}
// 获取我的会议
export function myMeetingPage(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: '/meet/meeting/myPage',
  })
}
// 获取预定会议室列表
export function getReserveRoomList(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: '/meet/meeting-room/queryMeetingRoomAndOccupyTimeSlot',
  })
}

// 获取预定会议详情
export function getMyMeetingDetails(data) {
  return $http({
    method: 'get',
    data: '',
    url: `/meet/meeting/${data}`,
  })
}

// 修改预定时间设置
export function updateGlobalSetting(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/meeting-global-setting/update`
  })
}

// 获取首页信息
export function getHomeUserSchedule(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/schedule/getHomeUserSchedule`
  })
}

/* 创建日程全部请求 */

// 创建日程
export function addSchedule(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/schedule/addSchedule`
  })
}
// 获取参会会人员的日程
export function getUserScheduleInTime(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/schedule/getUserScheduleInTime`
  })
}
// 获取日程详情
export function getScheduleDetail(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/schedule/getScheduleDetail`
  })
}
// 文件上传
export function uploadPermissions(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/admin/ddOpenApi/getCustomSpaceAndGrantCustomSpace`
  })
}
// 文件预览
export function previewPermissions(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/admin/ddOpenApi/getCustomSpaceAndGrantCustomSpace`
  })
}
// 编辑日程
export function modifySchedule(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/schedule/modifySchedule`
  })
}
// 删除日程
export function deleteSchedule(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/schedule/deleteSchedule`
  })
}
// 可用会议室列表
export function queryAvailableMeetingRoomByTime(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/meeting-room/queryAvailableMeetingRoomByTime`
  })
}
// 跨天会议判断是否可点击
export function getAllScheduleWithMeetingRoomByTime(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/meeting-room/getAllScheduleWithMeetingRoomByTime`
  })
}
// 获取动态展示
export function getDynamic(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/meeting-log/list`
  })
}
// 获取动态展示
export function saveFileInfo(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/meeting-log-resource/save`
  })
}
// 删除文件
export function delFile(data) {
  return $http({
    method: 'get',
    url: `/meet/schedule-accessory/remove/${data}`
  })
}
// 编辑文件
export function editFile(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/schedule-accessory/update`
  })
}
// 参加 不参加
export function isParticipate(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/schedule/confirm`
  })
}

//会议室详情的获取动态列表
export function getMeetingRoomAffairs(id) {
  return $http({
    method: 'get',
    url: `/meet/meeting-log/detail/${id}`
  })
}
//会议室创建新任务
export function createMeetingTask(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/meeting-log-resource/save`
  })
}
//会议室修改任务
export function updateMeetingTask(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/meeting-log-resource/update`
  })
}
//删除任务
export function deleteMeetingTask(id) {
  return $http({
    method: 'get',
    url: `/meet/meeting-log-resource/remove/${id}`
  })
}
// 测试的首页api
export function getHomeUserSchedule1(data) {
  return $http({
    method: 'POST',
    data: JSON.stringify(data),
    url: '/meet/schedule/getHomeUserSchedule1',
  })
}

// 动态list
export function getDynamicList(data) {
  return $http({
    method: 'get',
    data: data,
    url: `/meet/meeting-log/page`
  })
}

// 我的动态会议置顶
export function meetingCollection(data) {
  return $http({
    method: 'POST',
    data: JSON.stringify(data),
    url: '/meet/schedule/collection',
  })
}